//+------------------------------------------------------------------+
//|                                                         FIBO.mq4 |
//|                                                           BoraBo |
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                         Acceleration & Speed.mq4 |
//|                                                           Kharko |
//+------------------------------------------------------------------+
#property copyright "BoraBo"
#property link      ""

#property indicator_separate_window
#property  indicator_buffers 6
#property  indicator_color1  LightGray
#property  indicator_width1  2
#property  indicator_color2  Blue
#property  indicator_width2  2
#property  indicator_color3  Red
#property  indicator_width3  2
#property  indicator_color4  Blue
#property  indicator_width4  2
#property  indicator_color5  Red
#property  indicator_width5  2

//---- indicator parameters
extern string helpPriceAS ="1-O; 2-C; 3-H; 4-L; 5-(O+C)/2; 6-(H+L)/2; 7-(H+L+C)/3; 8-(H+L+C+O)/4; 0-(H+L+C+C)/4";
extern int    priceAS       = 2;        
extern int    Bar          = 2;        // 
extern bool    showFiboSell= true;
extern bool    showFiboBuy = true;
extern color   colorFiboSell= Red;
extern color   colorFiboBuy = Blue;
extern string  shortName="Fibo";


double     acsBuffer[];
double     maxAcsBuffer[];
double     minAcsBuffer[];
double     spBuffer[];
double     buyBuffer[];
double     sellBuffer[];
int prevTime=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() 
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,acsBuffer);
   SetIndexLabel(0,"Acs");
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,maxAcsBuffer);
   SetIndexLabel(1,"maxAcs");
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,minAcsBuffer);
   SetIndexLabel(2,"minAcs");
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexBuffer(3,buyBuffer);
   SetIndexArrow(3,SYMBOL_ARROWUP);
   SetIndexLabel(3,"BuyPoint");
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexBuffer(4,sellBuffer);
   SetIndexArrow(4,SYMBOL_ARROWDOWN);
   SetIndexLabel(4,"SellPoint");
   SetIndexStyle(5,DRAW_NONE);
   SetIndexBuffer(5,spBuffer);
   SetIndexLabel(5,"Speed");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() 
  {
//----
   DelObj();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() 
  {
   int    limit,Error,i,j;
//---- last counted bar will be recounted
   int counted_bars=IndicatorCounted();

   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars-Bar;

   if(limit<1) limit=1;

   for(i=0;i<limit;i++) 
     {
      spBuffer[i]=(value(i)-value(i+Bar))/Point;
     }

   for(i=0;i<limit;i++) 
     {
      acsBuffer[i]=spBuffer[i]-spBuffer[i+Bar];
     }

   for(i=0;i<limit;i++) 
     {
      if(acsBuffer[i+2]>=acsBuffer[i+3] && acsBuffer[i+2]>=acsBuffer[i+1] && acsBuffer[i+2]>0) 
        {
         maxAcsBuffer[i+2]=acsBuffer[i+2];
         if(iFractals(NULL,0,MODE_UPPER,i+2)>0)
           {
            sellBuffer[i+2]=maxAcsBuffer[i+2];
           }
        }

      if(acsBuffer[i+2]<=acsBuffer[i+3] && acsBuffer[i+2]<=acsBuffer[i+1] && acsBuffer[i+2]<0) 
        {
         minAcsBuffer[i+2]=acsBuffer[i+2];
         if(iFractals(NULL,0,MODE_LOWER,i+2)>0) 
           {
            buyBuffer[i+2]=minAcsBuffer[i+2];
           }
        }
     }

   for(i=0;i<limit;i++) 
//   for(i=limit-1;i>0;i--) 
     {
      if(showFiboSell)
        {
         if(acsBuffer[i]>0 && acsBuffer[i+1]<=0)
           {
            SetFiboSell(i);
           }
        }
      if(showFiboBuy)
        {
         if(acsBuffer[i]<0 && acsBuffer[i+1]>=0)
           {
            SetFiboBuy(i);
           }
        }
     }

//----
   return(0);
  }
//+------------------------------------------------------------------+
int SetFiboSell(int nB)
  {
   int res=-1,i=1;
   double priceStart;

   while(maxAcsBuffer[nB+i]==EMPTY_VALUE && nB+i<Bars)
     {
      i++;
     }

   if(maxAcsBuffer[nB+i]==sellBuffer[nB+i] && maxAcsBuffer[nB+i]!=EMPTY_VALUE)
     {
      res=nB+i;
      priceStart=High[res]-((High[res]-(Open[nB]+Close[nB])/2)/0.236);
      if(priceStart<High[res]) DrawFibo(Time[nB],Time[nB],priceStart,High[res],colorFiboSell);
     }

   return(res);
  }
//+------------------------------------------------------------------+
int SetFiboBuy(int nB)
  {
   int res=-1,i=1;
   double priceStart;

   while(minAcsBuffer[nB+i]==EMPTY_VALUE && nB+i<Bars)
     {
      i++;
     }

   if(minAcsBuffer[nB+i]==buyBuffer[nB+i] && minAcsBuffer[nB+i]!=EMPTY_VALUE)
     {
      res=nB+i;
      priceStart=Low[res]-((Low[res]-(Open[nB]+Close[nB])/2)/0.236);
      if(priceStart>Low[res]) DrawFibo(Time[nB],Time[nB],priceStart,Low[res],colorFiboBuy);
     }

   return(res);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DrawFibo(datetime timeStart,datetime timeEnd,double priceStart,double priceEnd,color clrLevel)
  {
   string name=shortName+"_"+TimeToStr(timeEnd);
   ObjectCreate(name,OBJ_FIBO,0,timeStart,priceStart,timeEnd,priceEnd);
   ObjectSet(name,OBJPROP_RAY,false);
   ObjectSet(name,OBJPROP_COLOR,Gray);
   ObjectSet(name,OBJPROP_STYLE,STYLE_SOLID);
   ObjectSet(name,OBJPROP_FIBOLEVELS,8);
   ObjectSet(name,OBJPROP_FIRSTLEVEL+0,0);
   ObjectSet(name, OBJPROP_FIRSTLEVEL + 1, 0.236);
   ObjectSet(name, OBJPROP_FIRSTLEVEL + 2, 0.382);
   ObjectSet(name, OBJPROP_FIRSTLEVEL + 3, 0.500);
   ObjectSet(name, OBJPROP_FIRSTLEVEL + 4, 0.618);
   ObjectSet(name, OBJPROP_FIRSTLEVEL + 5, 0.764);
   ObjectSet(name, OBJPROP_FIRSTLEVEL + 6, 1.000);
   ObjectSet(name, OBJPROP_FIRSTLEVEL + 7, 1.618);
   ObjectSet(name,OBJPROP_LEVELCOLOR,clrLevel);
   ObjectSetFiboDescription(name,0,"0 %");
   ObjectSetFiboDescription(name,1,"23.6 %");
   ObjectSetFiboDescription(name,2,"38.2 %");
   ObjectSetFiboDescription(name,3,"50 %");
   ObjectSetFiboDescription(name,4,"61.8 %");
   ObjectSetFiboDescription(name,5,"76.4 %");
   ObjectSetFiboDescription(name,6,"100 %");
   ObjectSetFiboDescription(name,7,"161.8 %");

  }
//============    ==========================
void DelObj()
  {
   int    objTot=ObjectsTotal();

   for(int i=0;i<objTot;i++)
     {
      if(StringFind(ObjectName(i),shortName,0)>=0)
        {
         ObjectDelete(ObjectName(i));
         i--;
         continue;
        }

      if(i>=ObjectsTotal()) break;
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double value(int i) 
  {
   switch(priceAS) 
     {

      case 1:
         return(Open[i]);

      case 2:
         return(Close[i]);

      case 3:
         return(High[i]);

      case 4:
         return(Low[i]);

      case 5:
         return((Open[i]+Close[i])/2);

      case 6:
         return((High[i]+Low[i])/2);

      case 7:
         return((High[i]+Low[i]+Close[i])/3);

      case 8:
         return((High[i]+Low[i]+Close[i]+Open[i])/4);

      default:
         return((High[i]+Low[i]+Close[i]+Close[i])/4);
     }

  }
//+------------------------------------------------------------------+

